/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.viewers.HapticViewer3D.unused;

/**
 * Comment by Łukasz Czerwiński: this class was intended to use HLAPI force effects to generate
 * forces. Currently it's not used - all forces are generated manually in
 * ForceContext.computeForce() and there is no need to split generating forces into two places -
 * some forces to be generated by HLAPI haptic effects and other - by manual generation in
 * computeForce().
 * <p/>
 * @deprecated NOT USED
 * <p/>
 * @author Krzysztof Madejski <krzysztof@madejscy.pl> ICM, University of Warsaw
 */
public class HLForceContext /* extends ForceContext */

{
    //
    //    private List<BaseEffect> baseEffectsToStart = new ArrayList<BaseEffect>();
    //    private List<BaseEffect> baseEffectsToStop = new ArrayList<BaseEffect>();
    //
    //    public HLForceContext(DeviceContext deviceContext, CoordinatesMode coordinatesMode) {
    //        super(deviceContext, coordinatesMode);
    //        if (!(deviceContext.getDevice() instanceof IPhantom)) {
    //            throw new IllegalArgumentException("HL context only operate on Phantom devices");
    //        }
    //    }
    //
    //    @Override
    //    public synchronized void addForce(IForce force) {
    //        if (force instanceof BaseEffect) {
    //            if (isCurrent()) {
    //                addBaseEffect((BaseEffect) force);
    //
    //            } else if (!baseEffectsToStop.remove((BaseEffect) force)) {
    //                baseEffectsToStart.add((BaseEffect) force);
    //
    //            }
    //        } else {
    //            super.addForce(force);
    //        }
    //    }
    //
    ////    @Override
    ////    public synchronized void makeCurrent() {
    ////        super.makeCurrent();
    ////
    ////        synchronized (HLAPI.frameLock) {
    ////            context.makeCurrent();
    ////            for (BaseEffect b : baseEffectsToStop) {
    ////                removeBaseEffect(b);
    ////            }
    ////            for (BaseEffect b : baseEffectsToStart) {
    ////                addBaseEffect(b);
    ////            }
    ////        }
    ////    }
    //    @Override
    //    public synchronized boolean removeForce(IForce force) {
    //        if (force instanceof BaseEffect) {
    //            if (isCurrent()) {
    //                removeBaseEffect((BaseEffect) force);
    //
    //            } else if (!baseEffectsToStart.remove((BaseEffect) force)) {
    //                baseEffectsToStop.add((BaseEffect) force);
    //
    //            }
    //            return ((BaseEffect) force).isActive();
    //        } else {
    //            return super.removeForce(force);
    //        }
    //    }
    //
    //    private void addBaseEffect(BaseEffect eff) {
    //
    //        throw new UnsupportedOperationException("tymczasowo wyłączone!");
    //
    ////        synchronized (HLAPI.frameLock) {
    ////            context.makeCurrent();
    ////            try {
    ////                HLAPI.beginFrame();
    ////                try {
    ////                    eff.start();
    ////                } catch (HLException ex) {
    ////                    //already started
    ////                }
    ////                HLAPI.endFrame();
    ////            } catch (HLException ex) {
    ////                throw new IllegalStateException("Internal error: probably nested HLAPI.beginFrame", ex);
    ////            }
    ////        }
    //    }
    //
    //    private void removeBaseEffect(BaseEffect eff) {
    //        throw new UnsupportedOperationException("tymczasowo wyłączone!");
    //
    ////        synchronized (HLAPI.frameLock) {
    ////            context.makeCurrent();
    ////            try {
    ////                HLAPI.beginFrame();
    ////                eff.stop();
    ////                HLAPI.endFrame();
    ////            } catch (HLException ex) {
    ////                throw new IllegalStateException("Internal error: probably nested HLAPI.beginFrame", ex);
    ////            }
    ////        }
    //    }
    ////    @Override
    ////    protected void fireInactive() {
    ////        synchronized(HLAPI.frameLock) {
    ////            try {
    ////                context.makeCurrent();
    ////                Context.contextDevice(Device.INVALID_HANDLE);
    ////            } catch (HLException ex) {
    ////                //impossible
    ////                Logger.getLogger(HLForceContext.class.getName()).log(Level.SEVERE, "Impossible", ex);
    ////            }
    ////        }
    ////    }
}
